//===================================================================
// Apci8284s.pas
//-------------------------------------------------------------------
// aPCI-8284
// Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
// ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂
//===================================================================
unit Apci8284s;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	Apci8284w;

const
	szTitle			= 'Sample';
	WM_APCI8284	= WM_USER + 100;
	DMA_BUFSIZE	= $FFFF;
	LOCALADR		= $10000;
	INTCSR			= $68;
	DMAMODE0		= $80;
	DMAPADR0		= $84;
	DMALADR0		= $88;
	DMASIZ0			= $8c;
	DMADPR0			= $90;
	DMACSR0			= $a8;

type
  TMainForm = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
		DmaBuf: 	array[0..DMA_BUFSIZE-1] of BYTE;
		wLogSlot:	WORD;
  public
		procedure ResultMessage(strbuf:String);
		procedure ErrorMessage(wLogSlot:Word);
		procedure DmaView;

	protected
		procedure OnIrq( var Msg:TMessage ); message WM_APCI8284;


  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}
//===================================================================
// 荞݃nh
//===================================================================
procedure TMainForm.OnIrq( var Msg:TMessage );
var
	slot:WORD;
begin
	slot:=Msg.WParam;
	ResultMessage('DMA ]܂(DEVICE  PC)');
	//-----------------------------------------------------------------
	// DMACSR0(DMA Channel 0 Command/Status Register ) ݒ
	//-----------------------------------------------------------------
	if Apci8284wMemWriteByte(slot,0,DMACSR0,$08) = False then begin
		ErrorMessage( APCI8284_SLOT_AUTO );
		Exit;
	end;
	//-----------------------------------------------------------------
	// DMA ]pobt@ǂݍ
	//-----------------------------------------------------------------
	if Apci8284wDmaRead(slot,0,DmaBuf,DMA_BUFSIZE) = False then begin
		ErrorMessage( slot );
		Exit;
	end;
	DmaView;
end;
//===================================================================
// `cl`]Jn
//===================================================================
procedure TMainForm.FormCreate(Sender: TObject);
var
	strbuf:String;
	DllVer,DrvVer:DWORD;
	Res:APCI8284RESOURCE;
	i:Integer;
	PhysAddr:DWORD;
begin
	wLogSlot:=APCI8284_SLOT_AUTO;
	//-----------------------------------------------------------------
	// Apci8284.dll J
	//-----------------------------------------------------------------
	if Apci8284wDllOpen = False then begin
		ErrorMessage( APCI8284_SLOT_AUTO );
		Halt;
	end;
	//-----------------------------------------------------------------
	// o[W\
	//-----------------------------------------------------------------
	if Apci8284wGetVersion(DllVer,DrvVer) = False then begin
		ErrorMessage( APCI8284_SLOT_AUTO );
		Halt;
	end;
	strbuf:=Format(
		'o[W'#10+
		'DLL:%XH'#10+
		'DRV:%XH',[DllVer,DrvVer]);
	ResultMessage(strbuf);
	//-----------------------------------------------------------------
	// foCXgp錾
	//-----------------------------------------------------------------
	if Apci8284wCreate(wLogSlot,Handle,WM_APCI8284) = False then begin
		ErrorMessage( APCI8284_SLOT_AUTO );
		Halt;
	end;
	strbuf:=Format(
		'foCX̎gp錾'#10+
		'LogSlot:%d',[wLogSlot]);
	ResultMessage(strbuf);
	//-----------------------------------------------------------------
	// \[X\
	//-----------------------------------------------------------------
	if Apci8284wGetResource(wLogSlot,@Res) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	strbuf:=Format(
		'\[X'#10+
		'I/O ̈搔:%d'#10,[Res.dwNumIoRegion]);
	for i:=1 to Res.dwNumIoRegion do begin
		strbuf:=strbuf+Format(
			'I/O AhX[%d]:%xH - %xH'#10,
			[i,Res.dwIoBase[i],Res.dwIoBase[i]+Res.dwIoLength[i]-1]);
	end;
	strbuf:=strbuf+Format(
		'MEM ̈搔:%d'#10,[Res.dwNumMemRegion]);
	for i:=1 to Res.dwNumMemRegion do begin
		strbuf:=strbuf+Format(
			'MEM AhX[%d]:%xH - %xH'#10,
			[i,Res.dwMemBase[i],Res.dwMemBase[i]+Res.dwMemLength[i]-1]);
	end;
	strbuf:=strbuf+Format(
		'荞:%d',[Res.dwIrq]);
	ResultMessage(strbuf);
	//-----------------------------------------------------------------
	// DMA ]pobt@m
	//-----------------------------------------------------------------
	if Apci8284wDmaAlloc(wLogSlot,DMA_BUFSIZE,PhysAddr) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	strbuf:=Format(
		'DMA ]pobt@mۂ܂'#10+
		'AhX=%XH'#10+
		'TCY=%XH'#10,[PhysAddr,DMA_BUFSIZE]);
	ResultMessage(strbuf);
	//-----------------------------------------------------------------
	// DMA ]pobt@[NA
	//-----------------------------------------------------------------
	FillChar(DmaBuf,DMA_BUFSIZE,0);
	if Apci8284wDmaWrite(wLogSlot,0,DmaBuf,DMA_BUFSIZE) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	ResultMessage('DMA ]pobt@[NA܂');
	//-----------------------------------------------------------------
	// DMA ]pobt@ǂݍ
	//-----------------------------------------------------------------
	if Apci8284wDmaRead(wLogSlot,0,DmaBuf,DMA_BUFSIZE) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	DmaView;
	ResultMessage('DMA ]Jn܂ DEVICE->PC');
	//-----------------------------------------------------------------
	// INTCSR(Interrupt Control/Status Register) ݒ
	//-----------------------------------------------------------------
	if Apci8284wMemWriteDWord(wLogSlot,0,INTCSR,$40100) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	//-----------------------------------------------------------------
	// DMAMODE0(DMA Channel 0 Mode Register) ݒ
	//-----------------------------------------------------------------
	if Apci8284wMemWriteDWord(wLogSlot,0,DMAMODE0,$20441) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	//-----------------------------------------------------------------
	// DMAPADR0(DMA Channel 0 PCI Address Register ) ݒ
	//-----------------------------------------------------------------
	if Apci8284wMemWriteDWord(wLogSlot,0,DMAPADR0,PhysAddr) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	//-----------------------------------------------------------------
	// DMALADR0(DMA Channel 0 Local Address Register ) ݒ
	//-----------------------------------------------------------------
	if Apci8284wMemWriteDWord(wLogSlot,0,DMALADR0,LOCALADR) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	//-----------------------------------------------------------------
	// DMASIZ0(DMA Channel 0 Transfer Size Register ) ݒ
	//-----------------------------------------------------------------
	if Apci8284wMemWriteDWord(wLogSlot,0,DMASIZ0,DMA_BUFSIZE) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	//-----------------------------------------------------------------
	// DMADPR0(DMA Channel 0 Descriptor Pointer Register ) ݒ
	//-----------------------------------------------------------------
	if Apci8284wMemWriteByte(wLogSlot,0,DMADPR0,$08) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	//-----------------------------------------------------------------
	// DMACSR0(DMA Channel 0 Command/Status Register ) ݒ
	//-----------------------------------------------------------------
	if Apci8284wMemWriteByte(wLogSlot,0,DMACSR0,$03) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
end;
//===================================================================
// I
//===================================================================
procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	//-----------------------------------------------------------------
	// DMA obt@J
	//-----------------------------------------------------------------
	if Apci8284wDmaFree(wLogSlot) = True then begin
		ResultMessage('DMA obt@J܂');
	end;
	//-----------------------------------------------------------------
	// foCX
	//-----------------------------------------------------------------
	if Apci8284wClose(wLogSlot) = True then begin
		ResultMessage(Format('foCX %d J܂',[wLogSlot]));
	end;
	//-----------------------------------------------------------------
	// Apci8284.dll 
	//-----------------------------------------------------------------
	if Apci8284wDllClose = True then begin
		ResultMessage('Apci8284.dll ܂');
	end;
end;
//===================================================================
// DMA ]pobt@̃ANZXpobt@̐擪oCg\
//===================================================================
procedure TMainForm.DmaView;
var
	strbuf:String;
	i,j,cnt:Integer;
begin
	//-----------------------------------------------------------------
	// \
	//-----------------------------------------------------------------
	cnt:=0;
	strbuf:='DMA ]pobt@ǂݍ݂܂'+#10;
	for i:=0 to $F do begin
		for j:=0 to $F do begin
			strbuf:=strbuf+IntToHex(DmaBuf[cnt],2)+' ';
			inc(cnt);
		end;
		strbuf:=strbuf+#10;
	end;
	ResultMessage(strbuf);
end;
//===================================================================
// ʂ\
//===================================================================
procedure TMainForm.ResultMessage(strbuf:String);
begin
	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONINFORMATION);
end;
//===================================================================
// G[bZ[W\
//===================================================================
procedure TMainForm.ErrorMessage(wLogSlot:Word);
var
	dwRes:	DWord;
	strbuf:	String;
begin
	dwRes:=Apci8284wGetLastError(wLogSlot);
	if dwRes = APCI8284_ERR_WRAPDLL then begin
		strbuf:='DLL Load error';
	end else begin
		strbuf:=Format(
							'aPCI-8284 error'#10#10'Error code:%08xH',[dwRes]);
	end;
	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONSTOP);
end;

end.
