//===================================================================
// Apci8284w.c - wrapper for C/C++
//-------------------------------------------------------------------
// Copyright (c) ADTEK SYSTEM SCIENCE Co.,Ltd.
//===================================================================
#include <windows.h>
#include <tchar.h>

#include "Apci8284w.h"

static BOOL	   _Apci8284wGetDllExportFunc( void );
static HMODULE hDLL = NULL;

static FARPROC pApci8284GetVersion;
static FARPROC pApci8284Create;
static FARPROC pApci8284Close;
static FARPROC pApci8284GetResource;
static FARPROC pApci8284GetLastError;
static FARPROC pApci8284IoReadByte;
static FARPROC pApci8284IoReadWord;
static FARPROC pApci8284IoReadDWord;
static FARPROC pApci8284IoWriteByte;
static FARPROC pApci8284IoWriteWord;
static FARPROC pApci8284IoWriteDWord;
static FARPROC pApci8284MemReadByte;
static FARPROC pApci8284MemReadWord;
static FARPROC pApci8284MemReadDWord;
static FARPROC pApci8284MemWriteByte;
static FARPROC pApci8284MemWriteWord;
static FARPROC pApci8284MemWriteDWord;
static FARPROC pApci8284DmaAlloc;
static FARPROC pApci8284DmaRead;
static FARPROC pApci8284DmaWrite;
static FARPROC pApci8284DmaFree;

//===================================================================
//   		DLL [h
//   		Ȃ
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Apci8284wDllOpen( void )
{
	if ( hDLL != NULL ) return FALSE;
	hDLL = (HMODULE)LoadLibrary(APCI8284_DLL_NAME);
	if ( hDLL == NULL ) return FALSE;
	if ( _Apci8284wGetDllExportFunc() == FALSE ) {
		Apci8284wDllClose();
		return FALSE;
	}
	return TRUE;
}
//===================================================================
//   		DLL A[h
//   		Ȃ
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Apci8284wDllClose( void )
{
	if ( hDLL == NULL ) return FALSE;
	if ( FreeLibrary(hDLL) == TRUE ) {
		hDLL = NULL;
		return TRUE;
	}
	return FALSE;
}
//===================================================================
//   		DLL,Driver ̃o[W擾
//   		pdwDllVer			DLL o[Wԍi[̈
//				pdwDrvVer			DRV o[Wԍi[̈
// ߂l		 TRUE
//				s FALSE
//===================================================================
BOOL Apci8284wGetVersion( PDWORD pdwDllVer, PDWORD pdwDrvVer )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci8284GetVersion)(pdwDllVer, pdwDrvVer);
}
//===================================================================
//   		foCXgp錾
//   		pwLogSlot			gpfoCXԍi[̈
// ߂l		 TRUE
//				s FALSE
//===================================================================
BOOL  Apci8284wCreate( PWORD pwLogSlot, HWND  hWnd, UINT  uWMBase )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci8284Create)(pwLogSlot,hWnd,uWMBase);
}
//===================================================================
//   		foCXJ
//   		wLogSlot			foCX̘_Xbgԍ
// ߂l		 TRUE
//				s FALSE
//===================================================================
BOOL Apci8284wClose( WORD wLogSlot )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci8284Close)(wLogSlot);
}
//===================================================================
//   		\[X擾
//   		wLogSlot			foCX̘_Xbgԍ
//				pRes				\[Xi[̈
// ߂l		 TRUE
//				s FALSE
//===================================================================
BOOL Apci8284wGetResource( WORD wLogSlot, PAPCI8284R pRes )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci8284GetResource)(wLogSlot,pRes);
}
//===================================================================
//   		G[擾
//   		wLogSlot			foCX̘_Xbgԍ
// ߂l		G[
//===================================================================
DWORD Apci8284wGetLastError( WORD wLogSlot )
{
	if ( hDLL == NULL ) return APCI8284_ERR_WRAPDLL;
	return (*pApci8284GetLastError)(wLogSlot);
}
//===================================================================
//   	I/O BYTE  ǂݍ
//   	wLogSlot				foCX̘_Xbgԍ
//			wRegion					\[Ẍ
//			wOffset					ItZbg
//
// ߂l  True
//				s False
//===================================================================
BOOL Apci8284wIoReadByte( WORD wLogSlot, WORD wRegion, DWORD dwOffset, PBYTE pbData )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci8284IoReadByte)(wLogSlot,wRegion,dwOffset,pbData);
}
//===================================================================
//   	I/O WORD  ǂݍ
//   	wLogSlot				foCX̘_Xbgԍ
//			wRegion					\[Ẍ
//			wOffset					ItZbg
//
// ߂l  True
//				s False
//===================================================================
BOOL Apci8284wIoReadWord( WORD wLogSlot, WORD wRegion, DWORD dwOffset, PWORD pwData )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci8284IoReadWord)(wLogSlot,wRegion,dwOffset,pwData);
}
//===================================================================
//   	I/O DWORD ǂݍ
//   	wLogSlot				foCX̘_Xbgԍ
//			wRegion					\[Ẍ
//			wOffset					ItZbg
//
// ߂l  True
//				s False
//===================================================================
BOOL Apci8284wIoReadDWord( WORD wLogSlot, WORD wRegion, DWORD dwOffset, PDWORD	pdwData )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci8284IoReadDWord)(wLogSlot,wRegion,dwOffset,pdwData);
}
//===================================================================
//   	I/O BYTE  
//   	wLogSlot				foCX̘_Xbgԍ
//			wRegion					\[Ẍ
//			wOffset					ItZbg
//
// ߂l  True
//				s False
//===================================================================
BOOL Apci8284wIoWriteByte( WORD wLogSlot, WORD wRegion, DWORD dwOffset, BYTE bData )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci8284IoWriteByte)(wLogSlot,wRegion,dwOffset,bData);
}
//===================================================================
//   	I/O WORD  
//   	wLogSlot				foCX̘_Xbgԍ
//			wRegion					\[Ẍ
//			wOffset					ItZbg
//
// ߂l  True
//				s False
//===================================================================
BOOL Apci8284wIoWriteWord( WORD wLogSlot, WORD wRegion, DWORD dwOffset, WORD wData )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci8284IoWriteWord)(wLogSlot,wRegion,dwOffset,wData);
}
//===================================================================
//   	I/O DWORD 
//   	wLogSlot				foCX̘_Xbgԍ
//			wRegion					\[Ẍ
//			wOffset					ItZbg
//
// ߂l  True
//				s False
//===================================================================
BOOL Apci8284wIoWriteDWord( WORD wLogSlot, WORD wRegion, DWORD dwOffset, DWORD dwData )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci8284IoWriteDWord)(wLogSlot,wRegion,dwOffset,dwData);
}
//===================================================================
//   	Memory BYTE  ǂݍ
//   	wLogSlot				foCX̘_Xbgԍ
//			wRegion					\[Ẍ
//			wOffset					ItZbg
//
// ߂l  True
//				s False
//===================================================================
BOOL Apci8284wMemReadByte( WORD wLogSlot, WORD wRegion, DWORD dwOffset, PBYTE pbData )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci8284MemReadByte)(wLogSlot,wRegion,dwOffset,pbData);
}
//===================================================================
//   	Memory WORD  ǂݍ
//   	wLogSlot				foCX̘_Xbgԍ
//			wRegion					\[Ẍ
//			wOffset					ItZbg
//
// ߂l  True
//				s False
//===================================================================
BOOL Apci8284wMemReadWord( WORD wLogSlot, WORD wRegion, DWORD dwOffset, PWORD pwData )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci8284MemReadWord)(wLogSlot,wRegion,dwOffset,pwData);
}
//===================================================================
//   	Memory DWORD ǂݍ
//   	wLogSlot				foCX̘_Xbgԍ
//			wRegion					\[Ẍ
//			wOffset					ItZbg
//
// ߂l  True
//				s False
//===================================================================
BOOL Apci8284wMemReadDWord( WORD wLogSlot, WORD wRegion, DWORD dwOffset, PDWORD pdwData )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci8284MemReadDWord)(wLogSlot,wRegion,dwOffset,pdwData);
}
//===================================================================
//   	Memory BYTE  
//   	wLogSlot				foCX̘_Xbgԍ
//			wRegion					\[Ẍ
//			wOffset					ItZbg
//
// ߂l  True
//				s False
//===================================================================
BOOL Apci8284wMemWriteByte( WORD wLogSlot, WORD wRegion, DWORD dwOffset, BYTE bData )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci8284MemWriteByte)(wLogSlot,wRegion,dwOffset,bData);
}
//===================================================================
//   	Memory WORD  
//   	wLogSlot				foCX̘_Xbgԍ
//			wRegion					\[Ẍ
//			wOffset					ItZbg
//
// ߂l  True
//				s False
//===================================================================
BOOL Apci8284wMemWriteWord( WORD wLogSlot, WORD wRegion, DWORD dwOffset, WORD wData )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci8284MemWriteWord)(wLogSlot,wRegion,dwOffset,wData);
}
//===================================================================
//   	Memory DWORD  
//   	wLogSlot				foCX̘_Xbgԍ
//			wRegion					\[Ẍ
//			wOffset					ItZbg
//
// ߂l  True
//				s False
//===================================================================
BOOL Apci8284wMemWriteDWord( WORD wLogSlot, WORD wRegion, DWORD dwOffset, DWORD dwData )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci8284MemWriteDWord)(wLogSlot,wRegion,dwOffset,dwData);
}
//===================================================================
//   	hCoɂcl`]obt@mۂ܂
//   	wLogSlot				foCX̘_Xbgԍ
//			dwMemSize				mۂTCYw
//			pdwAddress				mۂobt@̃AhXi[ϐ
//
// ߂l  True
//				s False
//===================================================================
BOOL Apci8284wDmaAlloc(WORD wLogSlot,DWORD dwMemSize,PDWORD pdwAddres)
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci8284DmaAlloc)(wLogSlot,dwMemSize,pdwAddres);
}
//===================================================================
//   	cl`]pobt@ǂݍ
//   	wLogSlot				foCX̘_Xbgԍ
//			dwOffset				ItZbgw肵܂
//			pbBuff			    	ǂݍ񂾃f[^i[̈̃|C^
//        	dwSize          		ǂݍރf[^w肵܂
//
// ߂l  True
//		  s False
//===================================================================
BOOL Apci8284wDmaRead(WORD wLogSlot,DWORD dwOffset,PBYTE pbBuff,DWORD dwSize)
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci8284DmaRead)(wLogSlot,dwOffset,pbBuff,dwSize);
}
//===================================================================
//   	cl`]pobt@
//   	wLogSlot				foCX̘_Xbgԍ
//			dwOffset				ItZbgw肵܂
//			pbBuff			    	ރf[^i[Ă̈̃|C^
//        	dwSize          		ރf[^w肵܂
//
// ߂l  True
//		  s False
//===================================================================
BOOL Apci8284wDmaWrite(WORD wLogSlot,DWORD dwOffset,PBYTE pbBuff,DWORD dwSize)
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci8284DmaWrite)(wLogSlot,dwOffset,pbBuff,dwSize);
}
//===================================================================
//   	cl`]obt@J
//   	wLogSlot				foCX̘_Xbgԍ
//
// ߂l  True
//				s False
//===================================================================
BOOL Apci8284wDmaFree(WORD wLogSlot)
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci8284DmaFree)(wLogSlot);
}
//-------------------------------------------------------------------
// 			DLL߰Ċ֐ڽ̎擾
// 			
// ߂l		 TRUE
//				s FALSE
//-------------------------------------------------------------------
static BOOL _Apci8284wGetDllExportFunc( void )
{
	pApci8284GetVersion		= GetProcAddress(hDLL, _T("Apci8284GetVersion"));
	pApci8284Create			= GetProcAddress(hDLL, _T("Apci8284Create"));
	pApci8284Close			= GetProcAddress(hDLL, _T("Apci8284Close"));
	pApci8284GetResource	= GetProcAddress(hDLL, _T("Apci8284GetResource"));
	pApci8284GetLastError	= GetProcAddress(hDLL, _T("Apci8284GetLastError"));
	pApci8284IoReadByte		= GetProcAddress(hDLL, _T("Apci8284IoReadByte"));
	pApci8284IoReadWord		= GetProcAddress(hDLL, _T("Apci8284IoReadWord"));
	pApci8284IoReadDWord	= GetProcAddress(hDLL, _T("Apci8284IoReadDWord"));
	pApci8284IoWriteByte	= GetProcAddress(hDLL, _T("Apci8284IoWriteByte"));
	pApci8284IoWriteWord	= GetProcAddress(hDLL, _T("Apci8284IoWriteWord"));
	pApci8284IoWriteDWord	= GetProcAddress(hDLL, _T("Apci8284IoWriteDWord"));
	pApci8284MemReadByte	= GetProcAddress(hDLL, _T("Apci8284MemReadByte"));
	pApci8284MemReadWord	= GetProcAddress(hDLL, _T("Apci8284MemReadWord"));
	pApci8284MemReadDWord	= GetProcAddress(hDLL, _T("Apci8284MemReadDWord"));
	pApci8284MemWriteByte	= GetProcAddress(hDLL, _T("Apci8284MemWriteByte"));
	pApci8284MemWriteWord	= GetProcAddress(hDLL, _T("Apci8284MemWriteWord"));
	pApci8284MemWriteDWord	= GetProcAddress(hDLL, _T("Apci8284MemWriteDWord"));
	pApci8284DmaAlloc		= GetProcAddress(hDLL, _T("Apci8284DmaAlloc"));
	pApci8284DmaRead		= GetProcAddress(hDLL, _T("Apci8284DmaRead"));
	pApci8284DmaWrite		= GetProcAddress(hDLL, _T("Apci8284DmaWrite"));
	pApci8284DmaFree		= GetProcAddress(hDLL, _T("Apci8284DmaFree"));


	if ( pApci8284GetVersion == NULL )		return FALSE;
	if ( pApci8284Create == NULL )			return FALSE;
	if ( pApci8284Close == NULL )			return FALSE;
	if ( pApci8284GetResource == NULL )		return FALSE;
	if ( pApci8284GetLastError == NULL )	return FALSE;
	if ( pApci8284IoReadByte == NULL )		return FALSE;
	if ( pApci8284IoReadWord == NULL )		return FALSE;
	if ( pApci8284IoReadDWord == NULL )		return FALSE;
	if ( pApci8284IoWriteByte == NULL )		return FALSE;
	if ( pApci8284IoWriteWord == NULL )		return FALSE;
	if ( pApci8284IoWriteDWord == NULL )	return FALSE;
	if ( pApci8284MemReadByte == NULL )		return FALSE;
	if ( pApci8284MemReadWord == NULL )		return FALSE;
	if ( pApci8284MemReadDWord == NULL )	return FALSE;
	if ( pApci8284MemWriteByte == NULL )	return FALSE;
	if ( pApci8284MemWriteWord == NULL )	return FALSE;
	if ( pApci8284MemWriteDWord == NULL )	return FALSE;
	if ( pApci8284DmaAlloc == NULL )		return FALSE;
	if ( pApci8284DmaRead == NULL )			return FALSE;
	if ( pApci8284DmaWrite == NULL )		return FALSE;
	if ( pApci8284DmaFree == NULL )			return FALSE;

	return TRUE;
}
